using FitConnect.Models;
using Route = FitConnect.Services.Models.v1.Routes.Route;

namespace FitConnect.Interfaces.Sender;

public interface ISender : IFitConnectClient {
    public string? PublicKey { get; }

    /// <summary>
    ///     Determines the destination id and configures the sender.
    /// </summary>
    /// <param name="leiaKey"></param>
    /// <param name="ags"></param>
    /// <param name="ars"></param>
    /// <param name="areaId"></param>
    /// <param name="receivedPublicKey">Callback for presenting the public key</param>
    /// <returns></returns>
    public Task<List<Route>> FindDestinationId(string leiaKey, string? ags = null,
        string? ars = null,
        string? areaId = null,
        Action<string>? receivedPublicKey = null);

    Task<Submission> SendAsync(SendableSubmission submission);
    Task<Submission> SendAsync(SendableEncryptedSubmission submission);
}
